



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>[Algorithms(Princeton)] Week1 - Percolation</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">[Algorithms(Princeton)] Week1 - Percolation</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-27 12:32:26 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<pre class="prettyprint linenums"> public class Percolation {<br />
     private boolean[] openSites;<br />
     private int gridN;<br />
     private WeightedQuickUnionUF UF;<br />
     private WeightedQuickUnionUF UFfull;

     public Percolation(int N) {<br />
         if (N &lt;= 0) {<br />
             throw new java.lang.IllegalArgumentException(<br />
             "N must be greater than 0");<br />
         }<br />
         openSites = new boolean[N * N];<br />
         gridN = N;<br />
         for (int i = 0; i &lt; N * N; ++i) {<br />
             openSites[i] = false;<br />
         }<br />
         // add 2 virtual sites<br />
         UF = new WeightedQuickUnionUF(N * N + 2);<br />
         UFfull = new WeightedQuickUnionUF(N * N + 1);<br />
     }

     private void indexChecker(int i, int j) {<br />
         if (i &lt; 1 || j &lt; 1 || i &gt; gridN || j &gt; gridN)<br />
             throw new java.lang.IndexOutOfBoundsException();<br />
     }

     public void open(int i, int j) {<br />
         indexChecker(i, j);

         int indexI = i - 1;<br />
         int indexJ = j - 1;

         int osIndex = indexI * gridN + indexJ;<br />
         if (openSites[osIndex])<br />
             return;<br />
         openSites[osIndex] = true;

         int ufIndex = indexI * gridN + indexJ + 1;<br />
         if (indexI == 0) {<br />
             UF.union(0, ufIndex);<br />
             UFfull.union(0, ufIndex);<br />
         }<br />
         if (indexI == gridN - 1) {<br />
             UF.union(ufIndex, gridN * gridN + 1);<br />
         }

         boolean bOpen = false;

         // union adjacent open sites<br />
         int leftIndexI = indexI;<br />
         int leftIndexJ = indexJ - 1;<br />
         if (leftIndexJ &gt;= 0) {<br />
             bOpen = isOpen(leftIndexI + 1, leftIndexJ + 1);<br />
             if (bOpen) {<br />
                 int leftUFIndex = leftIndexI * gridN + leftIndexJ + 1;<br />
                 UF.union(leftUFIndex, ufIndex);<br />
                 UFfull.union(leftUFIndex, ufIndex);<br />
             }<br />
         }

         int rightIndexI = indexI;<br />
         int rightIndexJ = indexJ + 1;<br />
         if (rightIndexJ &lt; gridN) {<br />
             bOpen = isOpen(rightIndexI + 1, rightIndexJ + 1);<br />
             if (bOpen) {<br />
                 int rightUFIndex = rightIndexI * gridN + rightIndexJ + 1;<br />
                 UF.union(ufIndex, rightUFIndex);<br />
                 UFfull.union(ufIndex, rightUFIndex);<br />
             }<br />
         }

         int upIndexI = indexI - 1;<br />
         int upIndexJ = indexJ;<br />
         if (upIndexI &gt;= 0) {<br />
             bOpen = isOpen(upIndexI + 1, upIndexJ + 1);<br />
             if (bOpen) {<br />
                 int upUFIndex = upIndexI * gridN + upIndexJ + 1;<br />
                 UF.union(upUFIndex, ufIndex);<br />
                 UFfull.union(upUFIndex, ufIndex);<br />
             }<br />
         }

         int downIndexI = indexI + 1;<br />
         int downIndexJ = indexJ;<br />
         if (downIndexI &lt; gridN) {<br />
             bOpen = isOpen(downIndexI + 1, downIndexJ + 1);<br />
             if (bOpen) {<br />
                 int downUFIndex = downIndexI * gridN + downIndexJ + 1;<br />
                 UF.union(ufIndex, downUFIndex);<br />
                 UFfull.union(ufIndex, downUFIndex);<br />
             }<br />
         }<br />
     }

     public boolean isOpen(int i, int j) {<br />
         indexChecker(i, j);<br />
         return (openSites[(i - 1) * gridN + j - 1]);<br />
     }

     public boolean isFull(int i, int j) {<br />
         indexChecker(i, j);<br />
         int indexI = i - 1;<br />
         int indexJ = j - 1;

         int osIndex = indexI * gridN + indexJ;<br />
         int ufIndex = osIndex + 1;

         boolean bOpen = isOpen(i, j);<br />
         boolean isFull = UFfull.connected(0, ufIndex);<br />
         return (bOpen &amp;&amp; isFull);<br />
     }

     public boolean percolates() {<br />
         if (gridN == 1)<br />
             return (openSites[0]);<br />
         return UF.connected(0, gridN * gridN + 1);<br />
     }<br />
 }</pre>
</div>
<p>You can see Percolation problem here.</p>
<p><a href="http://coursera.cs.princeton.edu/algs4/assignments/percolation.html" rel="external nofollow noreferrer">http://coursera.cs.princeton.edu/algs4/assignments/percolation.html</a></p>
<p>This problem is something related to Union-Find.</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/i/642120/201406/161750072071492.png" /></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qnnnegq.html">hotCity 小程序城市选择器， 城市数据库可自己导出</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zjvkx9.html">Linux下LVM</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdzlr09.html">LeetCode-Combinations</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mym608.html">Getting Started With Hazelcast 读书笔记&lpar;第四章&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q72jyk9.html">VHDL生成的ngc文件被verilog的工程调用的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv34pz8.html">angular源码分析：injector&period;js文件分析&mdash;&mdash;angular中的依赖注入式如何实现的（续）</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z0glxq.html">Android学习笔记之HttpClient实现Http请求&period;&period;&period;&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zk7w49.html">P235  实战练习（集合类2）、摇奖程序和验证码（修改版）</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xg3z09.html">Spring中使用quartz插件实现定时任务</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0r4olq.html">Android Density&lpar;密度&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mvkl48.html">Delphi回调函数及其使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yx2wr8.html">Git详解之六 Git工具（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpky7jq.html">&amp;lt&semi;Mastering KVM Virtualization&amp;gt&semi;：第三章 搭建独立的KVM虚拟化</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljgw509.html">javascript基础修炼&lpar;7&rpar;&mdash;&mdash;Promise，异步，可靠性</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp6ky0q.html">webrtc如何进行错误恢复</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwygly8.html">js 获取属性名称</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vpgx4q.html">android--------动画之进度条</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o40j25q.html">POI2010题解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvemypj9.html">Laravel 配置文件操作方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwo0v4z9.html">算法笔记&lowbar;075&colon;蓝桥杯练习 最短路（Java）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/m8zmv0d9.html">&lbrack;原创&rsqb;DELPHI木马DIY之生成服务端</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvxdxo8.html">GDB 使用大法</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jkn608.html">【转】INSTALL&lowbar;FAILED&lowbar;NO&lowbar;MATCHING&lowbar;ABIS 的解决办法</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mgpjr8.html">MogileFS 的介绍&lpar;MogileFS 系列1&rpar;&lbrack;分布式文件系统&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2r02o9.html">VMware的四种网络连接方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qypo5mq.html">膜拜（codevs 3369）</a>
			</li>
						<li><a href="https://www.batexi.com/a/39rowk79.html">XX管理系统案例</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mgxx68.html">如何用OpenCV自带的adaboost程序训练并检测目标</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdmlwjq.html">commons-fileupload实现文件上传下载</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qw6xw39.html">OOP 7大原则</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
